// add 0.2mm openings on every 10mm on an outline draw

// only draws and arcs > 10mm will be taken into account for now

// we start with draws (=easiest)

//find and store coordinates where to add opens

ArrayList openList = new ArrayList(); 
//draw>10mm?
deselectAll();
selectSmallTracks("+", "abs", "ctc", 10.0);
if(jobSelectCount()!=0) {
  cutToClipboard();
}

forEachApe() {
  forEachObject("arc") {
    // calculate the number of opens in the arcs
    radius=Math.sqrt((objFromPoint().x-objCenterPoint().x)*(objFromPoint().x-objCenterPoint().x)+(objFromPoint().y-objCenterPoint().y)*(objFromPoint().y-objCenterPoint().y));
    // Calculate the arc of the start to center line
    arcanglefrom=Math.toDegrees(Math.atan((objFromPoint().y-objCenterPoint().y)/(objFromPoint().x-objCenterPoint().x)));
    if (objFromPoint().x-objCenterPoint().x<0) arcanglefrom=arcanglefrom+180;
    if ((arcanglefrom<0)&&(objFromPoint().y-objCenterPoint().y<0)) arcanglefrom=arcanglefrom+360;   
    // calculate the arc from the end to center line
    arcangleto=Math.toDegrees(Math.atan((objToPoint().y-objCenterPoint().y)/(objToPoint().x-objCenterPoint().x)));
    if (objToPoint().x-objCenterPoint().x<0) arcangleto=arcangleto+180;
    if ((arcangleto<0)&&(objToPoint().y-objCenterPoint().y<0)) arcangleto=arcangleto+360;
    // depending on the sense of the arc the resulting arc can be calculated
    if (objSense().equals("cw")) {
      if (arcanglefrom<arcangleto) arcanglefrom=arcanglefrom+360;
      arcangle=arcanglefrom-arcangleto;
      arclength=arcangle*2*3.14159*radius/360;
      nrofopens=(int)((arclength-5)/10);
      startpoint=(arclength-10*nrofopens)/2;
      deltaangle=10*360/(2*3.14159*radius);
      // calculate the points to add the opens. 
      startangle=arcanglefrom-startpoint*360/(2*3.14159*radius);
      for(counter=0; counter<=nrofopens; counter++) {
        deltaX=objCenterPoint().x+(Math.cos(Math.toRadians(startangle-counter*deltaangle))*radius);      
        deltaY=objCenterPoint().y+(Math.sin(Math.toRadians(startangle-counter*deltaangle))*radius);     
        openList.add(Point(deltaX,deltaY));
      }
    } else {
      if (arcanglefrom>arcangleto) arcangleto=arcangleto+360;
      arcangle=arcangleto-arcanglefrom;
      arclength=arcangle*2*3.14159*radius/360;
      nrofopens=(int)((arclength-5)/10);
      startpoint=(arclength-10*nrofopens)/2;
      deltaangle=10*360/(2*3.14159*radius);
      // calculate the points to add the opens. 
      startangle=arcanglefrom+startpoint*360/(2*3.14159*radius);
      for(counter=0; counter<=nrofopens; counter++) {
        deltaX=objCenterPoint().x+(Math.cos(Math.toRadians(startangle+counter*deltaangle))*radius);      
        deltaY=objCenterPoint().y+(Math.sin(Math.toRadians(startangle+counter*deltaangle))*radius);     
        openList.add(Point(deltaX,deltaY));
      }
    }
  }
  forEachObject("dra") {
    //calculate number of opens to add
    drawlength=Math.sqrt((objFromPoint().x-objToPoint().x)*(objFromPoint().x-objToPoint().x)+(objFromPoint().y-objToPoint().y)*(objFromPoint().y-objToPoint().y));
    nrofopens=(int)((drawlength-5)/10);
    startpoint=(drawlength-10*nrofopens)/2;
    //calculate the angle of the current draw
    if (Math.abs(objFromPoint().x-objToPoint().x)<0.01) {
      if ((objFromPoint().y-objToPoint().y)<0) {
        drawangle=90;
      } else {
        drawangle=270;
      }        
    } else {
      drawangle=Math.toDegrees(Math.atan((objFromPoint().y-objToPoint().y)/(objFromPoint().x-objToPoint().x)));
      if (objFromPoint().x-objToPoint().x>0) drawangle=drawangle+180;
    }
    // calculate the points to add the opens. 
    for(counter=0; counter<=nrofopens; counter++) {
      deltaX=objFromPoint().x+(Math.cos(Math.toRadians(drawangle))*(startpoint+counter*10));      
      deltaY=objFromPoint().y+(Math.sin(Math.toRadians(drawangle))*(startpoint+counter*10));
      
      openList.add(Point(deltaX,deltaY));
    }
  }
}

pasteFromClipboard();
deselectAll();

for(counter=0; counter<=openList.size(); counter++) {
//  insertFlash(openList.get(counter));
  openDraw(openList.get(counter), 0.2);
}

